'use strict';
var cheerio = require('cheerio');
var _ = require('underscore');
var parse = require('url-parse');
var defaultConfig = {
	height: 300,
	theme: 0,
	defaultTab: 'result',
	description: ''
};

var template = _.template('<p data-height="<%= height %>" data-theme-id="<%= theme %>" data-slug-hash="<%= pen %>" data-default-tab="<%= defaultTab %>" data-user="<%= user %>" class="codepen">See the Pen <a href="http://codepen.io/<%= user %>/pen/<%= pen %>/"><%= description %></a> by <%= user %> (<a href="http://codepen.io/<%= user %>">@<%= user %></a>) on <a href="http://codepen.io">CodePen</a>.</p>');

module.exports = {
	book: {
		assets: '.',
		css: ['plugin.css']
	},
	hooks: {
		page: function(page) {
			var config = _.defaults(this.options.pluginsConfig.codepen, defaultConfig);
			var $ = cheerio.load(page.content);
			$('a').filter(function() {
				var href = this.attr('href');
				return parse(href).protocol === 'codepen:';
			}).each(function(index, a) {
				var rst = parse(a.attr('href'));
				a.replaceWith(template(_.extend({}, config, rst.query, {
					user: rst.username,
					pen: rst.password
				})));
			});
			page.content = $.html();
		},
		'body:end': function() {
			return '<script async src="//assets.codepen.io/assets/embed/ei.js"></script>';
		}
	}
};